`timescale 1ns / 1ps

module design1(
    input clk, reset,
    input [7:0] a,b,c, // a*b + c
    output reg [16:0] d
    );
    
    // buffer inputs
    reg [7:0] a_i,b_i,c_i;
    
    always @(posedge clk) begin
        a_i <= a;
        b_i <= b;
        c_i <= c;
    end
        
    // a*b
    wire [15:0] p;
    reg [7:0]  c_b;
    
    always @(posedge clk) begin
        if(reset) begin
            //p <= 0;
            c_b<= 0;
        end
        else begin
            //p <= a_i*b_i;
            c_b<= c_i;
        end
    end
    
    dsp_1 mult0 (clk, a_i, b_i, p);
    
    // p+c 
    always @(posedge clk) begin
        d <= p + c_b;
    end
    
endmodule
